// File:	DummyDigitizer.hh
// Date:	09-Oct-2001 G.Macharashvili Juelich
// Updated:

#ifndef DummyDigitizer_h
#define DummyDigitizer_h 1

#include "E391aHit.hh"
#include "E391aDigi.hh"
#include "TimeDigitizer.hh"

#include "E391aVDigitizerModule.hh"
#include "G4DigiManager.hh"

#include "CLHEP/Random/RandGaussQ.h"
#include "CLHEP/Random/RandPoissonQ.h"

class DummyDigitizer : public E391aVDigitizerModule {

static	const	G4bool		ESigmaON=true ;
static	const	G4bool		PSigmaON=true ;

static	const	G4double	MeV2QDC=1 ;
static	const	G4double	Npe2QDC=1 ;
static	const	G4double	QDCPSigma=1 ;

public:

	DummyDigitizer(G4String,int = 1) ;
	~DummyDigitizer() ;
  
	void		Digitize() ;
	void		Digitize(E391aHitsCollection*) ;

private:

	void		MakeDigi(E391aHit *H) ;
	G4double	PedestalRand() ;
	G4double	QDC(G4double e) ;

private:

	E391aHitsCollection		*HC ;
	E391aDigiCollection		*DC ;
	G4int				*DigiID ;
	G4int				xMaxDigi ;
	TimeDigitizer			TDC ;

	} ;

#endif

// EOF
