// File:		DynamicGamma.hh
// Date:		25-May-2001 G.Macharashvili Dubna

#if !defined Gamma_h
#define Gamma_h

#include <ostream.h>
#include "Map.hh"
#include "G4UnitsTable.hh"
#include "G4ThreeVector.hh"


class Gamma {

public:

static	const	G4double	Zec=6020*mm ;

protected:
	
	double		oX , oY , oZ , oE , oT ;
	double		oDx , oDy ;
	G4ThreeVector	Mom ;

public:

			~Gamma() ;
			Gamma(double =0,double =0,double =0,double =0,double =0,double =0) ;
			Gamma(const Gamma &g) ;
const	Gamma&		operator=(const Gamma &g) ;

	int	operator>(const Gamma &g) const ;
	int	operator<(const Gamma &g) const ;

	void		Print() ;
	void		SetT(double t) { oT=t ; }
	void		SetE(double e) { oE=e ; }
	void		SetX(double x) { oX=x ; }
	void		SetY(double y) { oY=y ; }
	void		SetZ(double z) { oZ=z ; }
	void		SetXY(double x,double y) { oX=x ; oY=y ; }
	void		InitMomentum(G4double Zdecay) ;
	double		T() const { return oT ; }
	double		E() const { return oE ; }
	double		X() const { return oX ; }
	double		Y() const { return oY ; }
	double		Z() const { return oZ ; }
	double		Dx() const { return oDx ; }
	double		Dy() const { return oDy ; }
	G4ThreeVector	P() const { return Mom ; }
	double		Theta() const { return Mom.theta() ; }
	double		Phi() const { return Mom.phi() ; }

	} ;

#endif

// EOF
