// File:	E391aCCo5.hh
// Date:	15-Oct-2001 G.Macharashvili Juelich

#ifndef E391aCCo5_h
#define E391aCCo5_h 1

#include "E391aVDigitizerModule.hh"
#include "DummyDetector.hh"
//#include "E391aCCo5-SD.hh"

#include "G4Material.hh"
#include "G4UserLimits.hh"
#include "G4ThreeVector.hh"
#include "G4VUserDetectorConstruction.hh"
#include "globals.hh"
#include "G4Box.hh"
#include "G4Cons.hh"
#include "G4Trd.hh"
#include "G4Trap.hh"
#include "G4Tubs.hh"
#include "G4Para.hh"
#include "G4LogicalVolume.hh"
#include "G4PVPlacement.hh"
#include "G4SDManager.hh"
#include "G4RunManager.hh"
#include "G4VisAttributes.hh"
#include "G4Colour.hh"
#include "G4RotationMatrix.hh"
#include "G4DigiManager.hh"

class E391aCCo5 {

// Geometry Constants ...
static	const	G4double	FrontEndZ=8450*mm ;
static	const	G4double	BackPlaneZ=FrontEndZ+400*mm ;
static	const	G4double	BeamHoleRadius=50*mm ;
static	const	G4double	OuterRadius=300*mm ;
// Identification data ...
static		G4String	Name ;
static	const	G4int		NumOfModules=1 ;
static	const	G4bool		Visible=true ;

public:
		E391aCCo5() ;
		~E391aCCo5() {}

	G4LogicalVolume*	Construct(G4VPhysicalVolume*World) ;
	void			Materials() ;
	void			Geometry() ;
	void			InfraStructure() ;
	void			Detector() ;
	void			Digitizer() ;
	void			Visualization() ;

protected: 

	G4VPhysicalVolume	*World ;
	G4Material		*CsI,*CeF3 ;
	G4UserLimits		*UL ;
  	G4Tubs			*Sol ;
	G4LogicalVolume		*Log ;
	G4VPhysicalVolume	*Phy ;
	G4VSensitiveDetector	*Det ;
	E391aVDigitizerModule	*Dig ;

	} ;
#endif

// EOF
