// File:	E391aDigi.hh
// Date:	10-May-2001 G.Macharashvili Dubna

#ifndef E391aDigi_h
#define E391aDigi_h 1

#include "G4VDigi.hh"
#include "G4TDigiCollection.hh"

class E391aDigi : public G4VDigi {

public:

		~E391aDigi() ;
		E391aDigi(G4int DetectorID=0,G4double q=0,G4double t=0) ;
		E391aDigi(const E391aDigi &r) ;

const	E391aDigi&	operator=(const E391aDigi &r) ;

	int	operator==(const E391aDigi &r) const ;
inline	void	*operator new(size_t) ;
inline	void	operator delete(void *h) ;
	void	Draw() ;
	void	Print() ;

public:

inline	void		SetDetectorID(G4int id) { xDetectorID=id ; }
inline	G4int		DetectorID() { return xDetectorID ; }
inline	G4int		SignalID() { return xDetectorID ; }

inline	void		SetQ(G4double q) { xQ=q ; }
inline	void		AddQ(G4double q) { xQ+=q ; }
inline	G4double	Q() { return xQ ; }

inline	void		SetT(G4double t) { xT=t ; }
inline	G4double	T() { return xT ; }

private:

	G4int		xDetectorID ;
	G4double	xQ ;
	G4double	xT ;

	} ;

typedef	G4TDigiCollection<E391aDigi>	E391aDigiCollection ;

extern	G4Allocator<E391aDigi>		E391aDigiAllocator ;

inline	void*	E391aDigi::operator new(size_t) {
//	G4cout<<"E391aDigi::new() \n" ;
	return (void *)E391aDigiAllocator.MallocSingle() ;
	}

inline	void	E391aDigi::operator delete(void *D) {
//	G4cout<<"E391aDigi::delete() \n" ;
	E391aDigiAllocator.FreeSingle((E391aDigi*) D);
	}

#endif

// EOF
