// File:	E391aVSensitiveDetector.hh
// Date:	22-Nov-2001 G.Macharashvili Dubna

#ifndef E391aVSensitiveDetector_h
#define E391aVSensitiveDetector_h 1

#include "E391aPType.hh"

#include "G4VSensitiveDetector.hh"
#include "G4StepStatus.hh"
#include "G4LogicalVolume.hh"
#include "G4TouchableHistory.hh"
#include "G4AffineTransform.hh"
#include "G4VSolid.hh"
#include "G4SDManager.hh"
#include "G4RunManager.hh"

class E391aVSensitiveDetector : public G4VSensitiveDetector {

public:

	E391aVSensitiveDetector(G4String,G4int = 1) ;
virtual	~E391aVSensitiveDetector() ;
  
//virtual	void		Initialize(G4HCofThisEvent*) {}
//virtual	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) { return false ; }
//virtual	void		EndOfEvent(G4HCofThisEvent*) {}

	G4int			StepClassifier(G4Step*) ;
	G4int			NumberOfDetectorModules() { return NumOfModules ; }
	G4int			CopyNo() const { return ModuleNo ; }
	G4int			EventID() const { return xEventID ; }
	G4int			TrackID() const { return xTrackID ; }
	G4int			ParID() const { return xParID ; }

private:

	G4int			NumOfModules ;
	G4int			ModuleNo ;
	G4TouchableHistory	*TH ;
	G4VSolid		*ModuleSolid ;
	G4int			*Aft ;
	G4AffineTransform	*AffineTrans , *AffineTransInverse ;

	G4int			xEventID ;
	G4int			xTrackID ;
	G4int			xParID ;
	G4int			SType ;

	} ;

#endif

// EOF
