// File:	EMShowerModel.hh
// Date:	15-Sep-2001 G.Macharashvili Dubna

#ifndef EMShowerModel_h
#define EMShowerModel_h 1

#include "G4VFastSimulationModel.hh"
#include "G4Step.hh"
#include "G4LogicalVolume.hh"
#include "G4VSensitiveDetector.hh"

class EMShowerModel : public G4VFastSimulationModel {

static	const	G4double	MinEk=20*MeV ;

public:

		EMShowerModel(G4String,G4LogicalVolume*) ;
		~EMShowerModel() ;

	G4bool		IsApplicable(const G4ParticleDefinition&) ;
	G4bool		ModelTrigger(const G4FastTrack&) ;
	void		DoIt(const G4FastTrack&,G4FastStep&) ;

private:

	G4LogicalVolume		*VLog ;
	G4VSensitiveDetector	*pSD ;

	};

#endif

// EOF
