// File:	SortedMap.hh
// 
// Date:	18-Jan-1999 G.Macharashvili JINR Dubna
// 
// Updated:	05-Nov-1999 G.Macharashvili JINR Dubna

#ifndef SMAP_HH
#define SMAP_HH

#include "PList.h"

template<class T> 
class SortedMap : public PList {

public:

	SortedMap(T* e=0,int n=128) ;
virtual	~SortedMap() {}

inline	T*	operator()(int indx) const { return (T*)PList::operator()(indx) ; }
inline	T*	operator[](int indx) const { return (T*)PList::operator[](indx) ; }
//inline	void	Add(const T* e) { PList::Add(e) ; }
//inline	void	Remove(const T* e) { PList::Remove(e) ; }
	void	Sort() ;
	void	Add(T *e=(T *)0) ;
	T*	Search(const T &a) ;
//inline	bool	SearchPtr(T *e=(T *)0) { return PList::SearchPtr(e) ; }
	void	DeleteAll() ;

	} ;

template<class T> SortedMap<T>::SortedMap(T* e,int n) : PList(n) {
	if (n<=0 || e==(void *)0) return ;
	while (n--) Add(e++) ;
	}

// Class <T> should support comparison operations ...
template<class T> void SortedMap<T>::Sort() {
	int i ;
	T   *a ;
	for (int j=1 ; j<NumOf() ; j++) {
		a=(T *)Ptr[j] ;
		i=j-1 ;
		while (i>=0 && *(T *)Ptr[i]>*a) {
			Ptr[i+1]=Ptr[i] ;
			--i ;
			}
		Ptr[i+1]=a ;
		}
	}

template<class T> void SortedMap<T>::Add(T* e) {
	if (e!=(T *)0) {
		PList::Add(e) ;
		int n=NumOf() ;
		while (--n && *(T *)Ptr[n-1]>*e) Ptr[n]=Ptr[n-1] ;
		Ptr[n]=e ;
		}
	}

template<class T> T* SortedMap<T>::Search(const T &a) {
	int i1=0 ;
	int i2=NumOf()-1 ;
	if (&a!=(T *)0) {
		while(1) {
			int i=i1+(i2-i1)/2 ;
			if (a==*(T *)Ptr[i]) return (T *)Ptr[i] ;
			if (i1==i2) break ;
			if (a<*(T *)Ptr[i]) i2=i ;
			else i1=i+1 ;
			}
		}
	return (T *)0 ;
	}
	
template<class T> void SortedMap<T>::DeleteAll() {
	int n=NumOf() ;
	while (n--) delete (T*)Ptr[n] ;
	Clear() ;
	}

#endif

//EOF
