// File:	TimeDigitizer.hh
// Date:	08-Nov-2001 G.Macharashvili Juelich
// Updated:

#ifndef TimeDigitizer_h
#define TimeDigitizer_h 1

#include "globals.hh"
#include "CLHEP/Random/RandGaussQ.h"
#include "CLHEP/Random/RandPoissonQ.h"

class TimeDigitizer {

protected:

static	const	G4bool		TSigmaON=true ; // ON/OFF fluctuations ...
static	const	G4int		MaxCount=4096-1 ; 
static	const	G4int		MinCount=1 ;
static	const	G4int		Shift=100 ;

public:

	TimeDigitizer(G4double xScale=0.05*ns,G4double xNoise=0.05*ns) ;
	~TimeDigitizer() ;
  
//	G4double	TDC(G4double t) ;
	G4double	operator()(G4double t) ;

private:

	G4double		Scale ;
	G4double		Noise ;

	} ;

#endif

// EOF
