// File:	E391aDetectorTable.cc
// Date:	01-Nov-2001 G.Macharashvili Dubna

#include "E391aDetectorTable.hh"

	G4int		E391aDetectorTable::Instance=0 ;

const	G4String	E391aDetectorTable::DetName[NN]={
	"EC" , "CCo1", "CCo2", "CCo3", "CCo4", "CCo5",
	"BC", "", "", "CH", "CHo", "SB", "BB" 
	} ;
const	G4int		E391aDetectorTable::NumOfModules[NN]={
	27 , 1, 1, 4, 1, 1, 1, 0, 0, 12, 1, 16, 32 
	} ;

	E391aDetectorTable::E391aDetectorTable() {
		if (!Instance) {

			Instance=1 ;
			}
		}

G4int	E391aDetectorTable::DetectorBaseID(G4String name) {
	for (int k=0 ; k<NN ; k++) {
		if (name==DetName[k]) return k ;
		}
	return -1 ;
	}

G4int	E391aDetectorTable::DetectorBaseID(const char* name) {
	for (int k=0 ; k<NN ; k++) {
		if (G4String(name)==DetName[k]) return k ;
		}
	return -1 ;
	}

// EOF
