// File:	E391aEventWriter.cc
// Date:	09-Oct-2001 G.Macharashvili Juelich

#include "E391aEventWriter.hh"

	E391aEventWriter	*E391aEventWriter::Ptr=0 ;

	E391aEventWriter::E391aEventWriter(const char *FileName=0) {
		if (Ptr) {
			cerr.form("E391aEventWriter::Singleton. Failed ...\n") ;
			exit(0) ;
			}
		buf=new int [2048*4] ;
		f=0 ;
		buf[2]=0 ;
		Ptr=this ;
		if (FileName) Open(FileName) ;
		}

bool	E391aEventWriter::Open(const char *fnm) {
	if (f) {
		cerr.form("E391aEventWriter:: %s - Already opened ...\n",fnm) ;
		return true ;
		}
	else if ((f=fopen(fnm,"wb"))<=0) {
		cerr.form("E391aEventWriter:: %s - Open Err ...\n",fnm) ;
		exit(0) ;
		}
	else return true ;
	}

bool	E391aEventWriter::Write() { 
	if (f>0) return (fwrite(buf,sizeof(int),buf[0],f)==buf[0]) ;
	else return true ;
	}

void	E391aEventWriter::Init(int run=0,int trig=0) { 
	p=buf+8 ; 
	buf[0]=8 ;		// xEventLength
	buf[1]=run ;		// xRunNumber
	buf[2]++ ;		// xEventSeqNumber
	buf[3]=time(0) ;	// xTime[2] for usec
	buf[4]=0 ;
	buf[5]=0 ; 		// xEventStatus (?)
	buf[6]=trig ;		// xTriggerDescriptor + DecayType
	buf[7]=0 ;		// xNumOfDigits
	}

bool	E391aEventWriter::GetDigits(const G4Event *E) {
	G4DCofThisEvent *DCE=E->GetDCofThisEvent() ;
	if (!DCE) return true ;
	G4int NumOfColl=DCE->GetNumberOfCollections() ;
	for (int k=0 ; k<NumOfColl ; k++) {
		E391aDigiCollection *DC=(E391aDigiCollection*)DCE->GetDC(k) ;
		if (DC) AddData(DC) ;
		}
	return true ;
	}

bool	E391aEventWriter::AddData(E391aDigiCollection *DC) {
	if (DC) for (int k=0 ; k<DC->entries() ; k++) AddData((*DC)[k]) ;
	return true ;
	}

bool	E391aEventWriter::AddData(E391aDigi *d) {
	return AddData(d->SignalID(),int(d->Q()+0.5),int(d->T()+0.5)) ;
	}

bool	E391aEventWriter::AddData(int id,double Q,double T) {
	return AddData(id,int(Q+0.5),int(T+0.5)) ;
	}

bool	E391aEventWriter::AddData(int id,int Q,int T) {
	*p++=id ;
	*p++=Signal(Q,T) ;
	buf[0]++ ; buf[0]++ ;
	buf[7]++ ;
	return true ;
	}

void	E391aEventWriter::Print() {
	G4cout.form("E391aEventWriter::EventSeqNum: %d\n",buf[2]) ;
	G4cout.form("EvtLen: %d  Trig: %d  NumOfDigi: %d\n",buf[0],buf[6],buf[7]) ;
	G4cout.form("EvtTime: %s",ctime((long *)(buf+3))) ;
	int *x=buf+8 ;
	for (int k=0 ; k<buf[7] ; k++) {
		G4cout.form(" %4d  %2.2d:%4.4d ",k,*x/10000,*x%10000) ;
		x++ ;
		G4cout.form("%8.8xd  ",(*x)) ;
		G4cout.form("%4d %4d",(*x)&0x8FFF,((*x)>>16)&0x8FFF) ;
		G4cout.form("\n") ;
		x++ ;
		}
	G4cout.form("\n") ;
	}

// EOF
