// File:	E391aHit.cc
// Date:	30-Aug-2001 G.Macharashvili Dubna
// Date:	24-Sep-2001 G.Macharashvili Juelich

#include "E391aHit.hh"

G4Allocator<E391aHit>		E391aHitsAllocator ;

E391aHit::E391aHit(G4int DetectorID,G4int ParticleID,G4double Ek,G4double E,G4double Time) {
	xDetectorID=DetectorID ;
	xParticleID=ParticleID ;
	xEKin=Ek ;
	xEDep=E ;
	xTime=Time ;
	xPath=0 ;
	xPos=0 ;
	xDir=0 ;
	}

E391aHit::E391aHit(G4int DetectorID,G4int ParticleID,G4Step *S) {
	xDetectorID=DetectorID ;
	xParticleID=ParticleID ;
	xEKin=S->GetPreStepPoint()->GetKineticEnergy() ;
	xTime=S->GetPreStepPoint()->GetGlobalTime() ;
	xEDep=S->GetTotalEnergyDeposit() ;
	xPath=S->GetStepLength() ;
	xPos=S->GetPreStepPoint()->GetPosition() ;
	xDir=S->GetPreStepPoint()->GetMomentumDirection() ;
	}

E391aHit::~E391aHit() {}

E391aHit::E391aHit(const E391aHit &r) {
	xDetectorID=r.xDetectorID ;
	xParticleID=r.xParticleID ;
	xEKin=r.xEKin ;
	xEDep=r.xEDep ;
	xTime=r.xTime ;
	xPath=r.xPath ;
	xPos=r.xPos ;
	xDir=r.xDir ;
	}

const	E391aHit& E391aHit::operator=(const E391aHit &r) {
	xDetectorID=r.xDetectorID ;
	xParticleID=r.xParticleID ;
	xEKin=r.xEKin ;
	xEDep=r.xEDep ;
	xTime=r.xTime ;
	xPath=r.xPath ;
	xPos=r.xPos ;
	xDir=r.xDir ;
	return *this ;
	}

int	E391aHit::operator==(const E391aHit &r) const {
	return (xDetectorID==r.xDetectorID && xParticleID==r.xParticleID) ;
	}

void E391aHit::Add(G4Step *S) {
	xEDep+=S->GetTotalEnergyDeposit() ;
	xPath+=S->GetStepLength() ;
	}

void	E391aHit::Print() {
	G4cout.form("E391aHit:") ;
	G4cout.form("%2.2d.",DetectorID()/10000) ;
	G4cout.form("%2.2d ",DetectorID()%10000) ;
	G4cout.form("P:%-2d ",xParticleID) ;
	G4cout.form("EKin:%6.3f GeV ",KineticEnergy()/GeV) ;
	G4cout.form("EDep:%6.3f MeV ",EDep()) ;
	G4cout.form("%6.2f ns",Time()/ns) ;
	G4cout.form("  (%.1f %.1f %.1f) ",X(),Y(),Z()) ;
	G4cout.form("\n") ;
	}

// EOF
