// File:	E391aPType.cc
// Date:	01-Jul-2001 G.Macharashvili Dubna

#include "E391aPType.hh"

#include <time.h>

int				E391aPType::Instance=0 ;
Map<G4ParticleDefinition>	E391aPType::P ;

E391aPType::E391aPType() {
	if (Instance) {}
		
	P.Add(G4Gamma::GammaDefinition()) ;		// 0
	P.Add(G4Electron::ElectronDefinition()) ;	// 1
	P.Add(G4Positron::PositronDefinition()) ;	// 2
	P.Add(G4MuonMinus::MuonMinusDefinition()) ;	// 3
	P.Add(G4MuonPlus::MuonPlusDefinition()) ;	// 4
	P.Add(G4PionMinus::PionMinusDefinition()) ;	// 5
	P.Add(G4PionPlus::PionPlusDefinition()) ;	// 6
	P.Add(G4PionZero::PionZeroDefinition()) ;	// 7

	P.Add(G4AntiNeutrinoE::AntiNeutrinoEDefinition()) ;	// 
	P.Add(G4AntiNeutrinoMu::AntiNeutrinoMuDefinition()) ;	// 
	P.Add(G4AntiNeutrinoTau::AntiNeutrinoTauDefinition()) ;	// 
	P.Add(G4NeutrinoE::NeutrinoEDefinition()) ;	// 
	P.Add(G4NeutrinoMu::NeutrinoMuDefinition()) ;	// 
	P.Add(G4NeutrinoTau::NeutrinoTauDefinition()) ;	// 

	P.Add(G4Proton::ProtonDefinition()) ;	// 
	P.Add(G4AntiProton::AntiProtonDefinition()) ;	// 
	P.Add(G4Neutron::NeutronDefinition()) ;	// 
	P.Add(G4AntiNeutron::AntiNeutronDefinition()) ;	// 
	P.Add(G4Lambda::LambdaDefinition()) ;	// 
	P.Add(G4AntiLambda::AntiLambdaDefinition()) ;	// 

	P.Add(G4KaonZeroLong::KaonZeroLongDefinition()) ;

	Print() ;
	Instance=1 ;
	}

E391aPType::~E391aPType() {}

void	E391aPType::Print() {
	G4cout.form("\nE391aPType:: E391a Particle Indexing rule\n") ;
	for (int k=0 ; k<P.NumOf() ; k++) {
		if (P[k]==0) continue ;
		G4cout.form("%2d %6d  %s\n",k,P[k]->GetPDGEncoding(),P[k]->GetParticleName().data()) ;
		}
	}

G4int	E391aPType::PType(G4ParticleDefinition *PDF) {
	return P.Index(PDF) ;
	}

G4int	E391aPType::PType(const char *S) {
	return PType(G4ParticleTable::GetParticleTable()->FindParticle(S)) ;
	}

G4int	E391aPType::PType(G4String &S) {
	return PType(S.data()) ;
	}

G4int	E391aPType::PType(G4DynamicParticle *DP) {
	return PType(DP->GetDefinition()) ;
	}
G4ParticleDefinition*	E391aPType::Definition(G4int index) {
	return P[index] ;
	}

// EOF
