// File:	E391aSteppingAction.cc
// Date:	16-Apr-2001 G.Macharashvili Juelich
// Updated:	21-Oct-2001 G.Macharashvili Juelich

#include "E391aSteppingAction.hh"

E391aSteppingAction::E391aSteppingAction(E391aDetectorConstruction* det)
	:
	xDet(det) {}

E391aSteppingAction::~E391aSteppingAction() {}

void	E391aSteppingAction::UserSteppingAction(const G4Step* Stp) {
static	const	G4String	SStat[8]= {
	"World.End",	"Vol.Bound",	"AtRestDoIt",	"AlongDoIt",
	"PostDoIt",	"UserLimit",	"Forced",	"Undef" } ;
static	const	G4String	TStat[6]= {
	"Tr.IsAlive",	"Tr.Stop.Alive",	"Tr.Stop.Kill",
	"Tr.Kill.All",	"Tr.Suspended",		"Tr.Postponed" } ;
	G4Track* Trk=Stp->GetTrack() ;
// Step Parameters
	G4StepPoint*	s1=Stp->GetPreStepPoint() ;
	G4StepPoint*	s2=Stp->GetPostStepPoint() ;
	G4double	SL=Stp->GetStepLength() ;
// Track Parameters
	G4ParticleDefinition*	P=	Trk->GetDefinition() ;
//	G4double		Ekin=	Trk->GetKineticEnergy() ;
//	G4String		PNam=	Trk->GetDefinition()->GetParticleName() ;
//	G4ThreeVector		Pos=	Trk->GetPosition() ;
	G4TrackStatus		TrStat=	Trk->GetTrackStatus() ;

//??	if (Trk->GetNextVolume()->GetName()=="OutOfWorld") Trk->SetTrackStatus(fKillTrackAndSecondaries) ;

// Control Print

/**************************************
	G4cout.form("T:") ;
	G4cout.form("%-4d",Trk->GetTrackID()) ;
	G4cout.form("S:") ;
	G4cout.form("%-4d",Trk->GetCurrentStepNumber()) ;

	G4VPhysicalVolume *V1=s1->GetPhysicalVolume() ;
	if (V1==0) G4cout.form(" (%p)",V1) ;
	else {
		G4cout.form(" %8s",V1->GetName().data()) ;
		G4cout.form(":%-2d",V1->GetCopyNo()) ;
		}
	G4cout.flush() ;

	G4VPhysicalVolume *V2=s2->GetPhysicalVolume() ;
	if (V2==0) G4cout.form(" (%p)",V2) ;
	else {
		G4cout.form(" %8s",V2->GetName().data()) ;
		G4cout.form(":%-2d",V2->GetCopyNo()) ;
		}
	G4cout.flush() ;

	G4cout.form(" SL:%5.1f",SL) ;

	G4cout.form(" SS:%-10s",SStat[s2->GetStepStatus()].data()) ;

//	G4cout.form(" %6.1f",SL) ;
//	G4cout.form(" %7.1f",s1->GetKineticEnergy()) ;
//	G4cout.form(" %7.1f",Stp->GetTotalEnergyDeposit()/MeV) ;

	const G4VProcess *PR=s1->GetProcessDefinedStep() ;
	if (PR) G4cout.form(" Proc:%s",PR->GetProcessName().data()) ;
	else G4cout.form(" Proc: 0 ptr") ;

	G4VPhysicalVolume *V=Trk->GetNextVolume() ;
	if (V) G4cout.form(" NextVol:%s",V->GetName().data()) ;
	G4cout.form("\n") ;
	G4cout.flush() ;

static	G4Navigator *Nav=0 ;
	if (Nav==0) Nav=G4TransportationManager::GetTransportationManager()->GetNavigatorForTracking() ;
	G4cout<<"   ExitNormalValid: "<<Nav->IsExitNormalValid() ;
	G4cout<<"   EnteredDaughter: "<<Nav->EnteredDaughterVolume() ;
	G4cout.form("\n") ;
	G4cout.flush() ;
**************************************/
	
	}

// EOF
