// File:	EMShowerModel.cc
// Date:	15-Sep-2001 G.Macharashvili Dubna
// from Ex05...


#include "EMShowerModel.hh"

//#include "RandomGamma.hh"
//#include "Randomize.hh"

#include "G4Electron.hh"
#include "G4Positron.hh"
#include "G4Gamma.hh"
//#include "G4TransportationManager.hh"
//#include "G4VSensitiveDetector.hh"
//#include "G4VTouchable.hh"

EMShowerModel::EMShowerModel(G4String MName,G4LogicalVolume* Env)
: G4VFastSimulationModel(MName,Env) {
	VLog=Env ;
	pSD=VLog->GetSensitiveDetector() ;
	}

EMShowerModel::~EMShowerModel() {}

G4bool EMShowerModel::IsApplicable(const G4ParticleDefinition& PType) {
	return 
		&PType==G4Electron::ElectronDefinition() ||
		&PType==G4Positron::PositronDefinition() ||
		&PType==G4Gamma::GammaDefinition() ;
	}

G4bool EMShowerModel::ModelTrigger(const G4FastTrack& FTrk) {
	return FTrk.GetPrimaryTrack()->GetKineticEnergy()>MinEk ;
	}

void EMShowerModel::DoIt(const G4FastTrack& FTrk,G4FastStep& FStp) {
	FStp.KillPrimaryTrack() ;
	FStp.SetPrimaryTrackPathLength(0.0) ;
	FStp.SetTotalEnergyDeposited(FTrk.GetPrimaryTrack()->GetKineticEnergy()) ;
	FStp.ForceSteppingHitInvocation() ;
	}

// EOF
