// File:	PList.cc
// 
// Date:	05-Oct-1998 G.Macharashvili JINR Dubna
// 
// Updated:	19-Jan-1999 G.Macharashvili JINR Dubna
// Updated:	01-Nov-1999 G.Macharashvili JINR Dubna

#include <stdio.h>
#include "PList.h"

	PList::PList(int size) {
		ElemNumb=MaxElemNumb=0 ; 
		Ptr=(void **)0 ;
		if (size>0) AddMemory(size) ;
		}

	PList::~PList() { if (Ptr) delete [] Ptr ; }

void	PList::AddMemory(int size) {
	size+=MaxElemNumb ;
	void **newPtr=(void **) new char[sizeof(void *)*size] ;
	void **oldPtr=Ptr ;
	if (newPtr==(void **)0) {
		printf("\nPList: Memory Allocation fault...\n\n") ;
		exit(1) ;
		}
	void **x=newPtr ;
	while (MaxElemNumb--) *x++=*oldPtr++ ;
	MaxElemNumb=size ;
	delete [] Ptr ;
	Ptr=newPtr ;
	}

void*	PList::operator()(int indx) const {
	if (indx<0 || indx>=ElemNumb) return (void*)0 ;
	else return Ptr[indx] ;
	}

void	PList::Print() {
	printf("\nPList: %d\n",ElemNumb) ;
	for (int k=0 ; k<ElemNumb ; k++) {
		printf("%p ",Ptr[k]) ; 
		}
	printf("\n ") ; 
	}

bool	PList::SearchPtr(const void *x) {
	for (int k=0 ; k<ElemNumb ; k++) {
		if (x==Ptr[k]) return true ; 
		}
	return false ; 
	}

void	PList::Swap(int i1,int i2) {
	if (i1<0 ||i1>=ElemNumb) return ;
	if (i2<0 ||i2>=ElemNumb) return ;
	void *x=Ptr[i1] ;
	Ptr[i1]=Ptr[i2] ;
	Ptr[i2]=x ;
	return ;
	}

int	PList::Index(const void *x) {
	for (int k=0 ; k<ElemNumb ; k++) {
		if (x==Ptr[k]) return k ; 
		}
	return (-1) ; 
	}

void	PList::Add(const void* x) { 
	if (x==(void*)0) return ;
	if (ElemNumb==MaxElemNumb) AddMemory(CHUNK) ;
	Ptr[ElemNumb++]=(void *)x ;
	}

void	PList::Remove(const void* x) {
	int k=0 ;
	void **y=Ptr ; 
	void **z=Ptr ;
	while (ElemNumb--) {
		if (*y==x) y++ ;
		else z[k++]=*y++ ;
		}
	ElemNumb=k ;
	}

void	PList::Remove(int indx) {
	if (indx<0 || indx>=ElemNumb) return ;
	if (indx!=ElemNumb-1) {
		for (int k=indx ; k<ElemNumb-1 ; k++) Ptr[k]=Ptr[k+1] ;
		}
	ElemNumb-- ;
	}

