// File:	StepClassifier.cc
// Date:	08-Nov-2001 G.Macharashvili Dubna

#include "StepClassifier.hh"

/*
static	const	G4String	SStat[8]= {
	"World.End",	"Vol.Bound",	"AtRestDoIt",	"AlongDoIt",
	"PostDoIt",	"UserLimit",	"Forced",	"Undef" } ;
*/
static	const	G4String	NavType[4]={"Inside","Enter ","Exit  ","Error " } ;

StepClassifier::StepClassifier() {}

StepClassifier::~StepClassifier() {}

G4int	StepClassifier::Index(G4Step *S,G4String VolName) {
	G4double DE=S->GetTotalEnergyDeposit() ;
	G4double SL=S->GetStepLength() ;
	G4StepPoint *S1=S->GetPreStepPoint() ;
	G4StepPoint *S2=S->GetPostStepPoint() ;
	G4StepStatus SS=S1->GetStepStatus() ;
	G4StepStatus SS2=S2->GetStepStatus() ;

	VName1=S1->GetPhysicalVolume()->GetName() ;
	VNo1=S1->GetPhysicalVolume()->GetCopyNo() ;
	VName2=S2->GetPhysicalVolume()->GetName() ;
	VNo2=S2->GetPhysicalVolume()->GetCopyNo() ;
//	SameVol=int(VName1==VName2 && VNo1==VNo2) ;
	SameVol=int(VName1==VName2) ;

static	G4Navigator *Nav=0 ;
	if (Nav==0) Nav=G4TransportationManager::GetTransportationManager()->GetNavigatorForTracking() ;
	if (Nav==0) return 3 ;

	Exit= Nav->IsExitNormalValid() ;
	Enter=Nav->EnteredDaughterVolume() ;
	G4int index=Exit*2+Enter ;
	G4VSolid *B=0 ;
	G4int EI=-1 ;

	B=S1->GetPhysicalVolume()->GetLogicalVolume()->GetSolid() ;
	if (B) EI=B->Inside(S1->GetPosition()) ;

	switch(index) {
		default:
			index=3 ; // This is eroor
			break ;
		case 0:	
			break ; // Simple step inside volume
		case 1: 	// EnterDaughter
		case 2: 	// Exit
			if (SS2==1) {
				VName=VName2 ;
				VCopyNo=VNo2 ;
				}
			else {
				VName=VName1 ;
				VCopyNo=VNo1 ;
				}
			break ;
		}
/*
	if (SameVol==0) G4cout.form("* ") ;
	else            G4cout.form("  ") ;
	G4cout.form("%s ",NavType[index].data()) ;
	G4cout.form("%d ",SS) ;
	G4cout.form("%d ",SS2) ;
	G4cout.form("%s ",VName1.data()) ;
	G4cout.form("%s ",VName2.data()) ;
	if (SL==0) G4cout.form("so ") ;
	else       G4cout.form("s+ ") ;
	if (DE==0) G4cout.form("do ") ;
	else       G4cout.form("d+ ") ;
	G4cout.form("%p ",B) ;
	G4cout.form("%d ",EI) ;
	G4cout.form("\n") ;
*/
	return index ;

	}

// EOF
