// File:	TimeDigitizer.cc
// Date:	08-Nov-2001 G.Macharashvili Juelich
// Updated:

#include "TimeDigitizer.hh"

TimeDigitizer::~TimeDigitizer() {}

TimeDigitizer::TimeDigitizer(G4double xScale,G4double xNoise) {
	Noise=xNoise ;
	Scale=xScale ;
	}

G4double TimeDigitizer::operator()(G4double t) { 
	G4double tdc=(TSigmaON) ? rint(t/Scale+RandGaussQ::shoot(0,Noise)+Shift) : Shift ;
	if (tdc<MinCount) return MinCount ;
	if (tdc>MaxCount) return MaxCount ;
	else return tdc ;
	}

/*
1. NOISE: explanation of sigma
2. light propagation speed (Veff=15cm/ns) in 
   scintillator bar (should be accounted) ...
3. 
*/

// EOF
