//

#ifdef G4VIS_USE

#include "VisManager.hh"

#ifdef G4VIS_USE_OPENGLX
#include "G4OpenGLImmediateX.hh"
#include "G4OpenGLImmediateXViewer.hh"
#include "G4OpenGLXViewer.hh"
#include "G4OpenGLStoredX.hh"
#endif

#ifdef G4VIS_USE_OPENGLXM
#include "G4OpenGLStoredXm.hh"
#endif

VisManager::VisManager(G4VPhysicalVolume *w) {
		World=w ;
		Initialize() ;
		}

void	VisManager::DetDraw() {
	GraphicsSystem() ;
	Draw(*World,*(World->GetLogicalVolume()->GetVisAttributes())) ;
//	PrintCurrentSystem() ;
G4ViewParameters& VP=SetCurrentViewParameters() ;
	VP.SetWindowSizeHint(300,200) ;
	VP.SetLightsMoveWithCamera(true) ;
	VP.SetViewAndLights(G4Vector3D(-1.0,0.4,-0.2)) ;
	VP.SetZoomFactor(3.95) ;
//	VP.SetViewAndLights(G4Vector3D(0,0,-1)) ;
//	VP.SetZoomFactor(3.95) ;
	VP.SetCurrentTargetPoint(G4Point3D(0,0,2*m)) ;
//	VP.SetDolly(10) ;
	VP.SetViewGeom() ;
	VP.ClearCutawayPlanes() ;
	VP.AddCutawayPlane(G4Plane3D(G4Normal3D(1,0,0),G4Point3D(0,0,0))) ;
	VP.AddCutawayPlane(G4Plane3D(G4Normal3D(0,1,0),G4Point3D(0,0,0))) ;

//	CreateViewer("G4: E391a Exp. Setup") ;

//	PrintCurrentView();
//	GetCurrentViewer()->SetViewParameters(VP) ;
//	GetCurrentViewer()->SetView() ;
		Draw() ;
		Show() ;
		G4cout<<"Close ? y/n: " ;
		G4cout.flush() ;
		G4int aq ;
		G4cin>>aq ;
		}

void	VisManager::RegisterGraphicsSystems () {
#ifdef G4VIS_USE_OPENGLX
	RegisterGraphicsSystem (GS=new G4OpenGLImmediateX) ;
//	RegisterGraphicsSystem (GS=new G4OpenGLStoredX) ;
//	G4cout <<"... Active: OPENGLX\n" ;
#endif

#ifdef G4VIS_USE_OPENGLXM
//	RegisterGraphicsSystem (GS=new G4OpenGLImmediateXm) ;
//	RegisterGraphicsSystem (GS=new G4OpenGLStoredXm) ;
//	G4cout <<"... Active: OPENGLXM\n" ;
#endif

//	G4cout <<"\n**** Graphics systems:\n" ;
	PrintAvailableGraphicsSystems() ;

	}

#endif

// EOF
